import Bladex
import math 



def SetRadialFireDamageObjectX(object_name, radius=500.0, floor_displ=0.0, roof_displ=2000.0):
	x, y, z = Bladex.GetEntity(object_name).Position
	dx=radius/2.0
	dz=radius*((math.sqrt(3.0))/2.0)
	trsector_name=object_name+"_TrSectorFire"
	Bladex.AddTriggerSector(trsector_name, "SectoresTriggerFuego", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
	LightMyFire(trsector_name)


FIRE_DAMAGE = 1.0/120.0

def FireTimer(entity, time):
	vict = Bladex.GetEntity(entity)
	MIN_LIFE=CharStats.GetCharMaxLife(vict.Kind,vict.Level)/10
	vict.Life = vict.Life - FIRE_DAMAGE * CharStats.GetCharMaxLife(vict.Kind,vict.Level)
	if vict.Life <= MIN_LIFE:
		vict.RemoveFromList("Timer15")
		vict.TimerFunc=""


def IntoFire(trsector,entity):
	vict=Bladex.GetEntity(entity)
	MIN_LIFE=CharStats.GetCharMaxLife(vict.Kind,vict.Level)/10
	if vict and vict.Person: 
		vict.LaunchAnmType("hurt_f_big")
		if vict.Life>MIN_LIFE:
        		vict.SubscribeToList("Timer15")
        		vict.TimerFunc=FireTimer
        		


def AwayFromFire(trsector,entity):
	vict=Bladex.GetEntity(entity)
	if vict and vict.Person: 
   		if vict.Life>0:
       			vict.RemoveFromList("Timer15")
       			vict.TimerFunc=""
        		

def LightMyFire(name):
	Bladex.SetTriggerSectorFunc(name, "OnEnter", IntoFire)
	Bladex.SetTriggerSectorFunc(name, "OnLeave", AwayFromFire)
	print "fire damage set"



o=Bladex.CreateEntity("Braseroaraa","Braseroaraa",0,0,0,"Physic")
o.Scale=1.8
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(0.0, 0.55, (255, 196, 128))]
SetRadialFireDamageObjectX(o.Name,2500)


o=Bladex.CreateEntity("TapizEscorpion_215","TapizEscorpion",33.5814976873,-4214.26561715,-35082.986834, Reference.ObjType("TapizEscorpion"))
o.Static=1
o.Scale=5.8
o.Orientation=(0.0,3.23650340306e-007,0.707106769085,-0.70710682869)


o=Bladex.CreateEntity("Tapizkemado1_216","Tapizkemado1",-25.3079998619,-3614.99970782,34986.1011206, Reference.ObjType("Tapizkemado1"))
o.Static=1
o.Scale=4.6
o.Orientation=(0.707106649876,0.707106888294,-1.44808296909e-007,2.35165131812e-008)
